<template>
    <v-container>
        <v-row>
            <v-col cols="12" sm="8" offset="2">
                <v-data-table :items="vehicles" :headers="headers" hide-default-footer>
                    <template v-slot:item.vgp="{item}">
                        <span>{{item.vgp | formatDate}}</span>
                    </template>
                    <template v-slot:item.controlTechnic="{item}">
                        <span>{{item.controlTechnic | formatDate}}</span>
                    </template>


                    <template v-slot:item.actions="{ item }">
                        <v-icon class="mr-2" @click="editItem(item)">mdi-pencil</v-icon>
                        <v-icon class="mr-2" @click="deleteItem(item)">mdi-delete</v-icon>
                        <v-icon class="mr-2" @click="detailItem(item)">search</v-icon>
                    </template>
                </v-data-table>
                <div>
                    <v-dialog v-model="dialog" max-width="500px">
                        <template v-slot:activator="{ on }">
                            <v-btn color="green" dark class="mb-2" v-on="on">Ajouter un véhicule</v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="headline">{{ formTitle }}</span>
                            </v-card-title>
                            <v-card-text>
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="12" md="12">
                                            <v-text-field v-model="editedItem.title" label="Titre"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-text-field v-model="editedItem.immat"
                                                          label="Immatriculation"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-text-field v-model="editedItem.modele"
                                                          label="Modèle"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-menu
                                                    ref="menuVgp"
                                                    v-model="menuVgp"
                                                    :close-on-content-click="false"
                                                    :return-value.sync="editedItem.vgp"
                                                    transition="scale-transition"
                                                    offset-y
                                                    min-width="290px">
                                                <template v-slot:activator="{ on }">
                                                    <v-text-field
                                                            :value="computedVgp"
                                                            label="VGP"
                                                            prepend-icon="event"
                                                            readonly
                                                            v-on="on"
                                                    ></v-text-field>
                                                </template>
                                                <v-date-picker v-model="editedItem.vgp"
                                                               locale="fr-FR" no-title scrollable>
                                                    <v-spacer></v-spacer>
                                                    <v-btn text color="primary" @click="menuVgp = false">Cancel</v-btn>
                                                    <v-btn text color="primary"
                                                           @click="$refs.menuVgp.save(editedItem.vgp)">OK
                                                    </v-btn>
                                                </v-date-picker>
                                            </v-menu>
                                        </v-col>
                                        <v-col cols="12" sm="6" md="6">
                                            <v-menu
                                                    ref="menuCT"
                                                    v-model="menuCT"
                                                    :close-on-content-click="false"
                                                    :return-value.sync="editedItem.controlTechnic"
                                                    transition="scale-transition"
                                                    offset-y
                                                    min-width="290px">
                                                <template v-slot:activator="{ on }">
                                                    <v-text-field
                                                            :value="computedCT"
                                                            label="Controle technique"
                                                            prepend-icon="event"
                                                            readonly
                                                            v-on="on"
                                                    ></v-text-field>
                                                </template>
                                                <v-date-picker v-model="editedItem.controlTechnic"
                                                               locale="fr-FR" no-title scrollable>
                                                    <v-spacer></v-spacer>
                                                    <v-btn text color="primary" @click="menuCT = false">Cancel</v-btn>
                                                    <v-btn text color="primary"
                                                           @click="$refs.menuCT.save(editedItem.controlTechnic)">OK
                                                    </v-btn>
                                                </v-date-picker>
                                            </v-menu>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-card-text>

                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="brown darken-1" text @click="close">Annuler</v-btn>
                                <v-btn color="brown darken-1" text @click="save">Enregistrer</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </div>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import axios from "axios";
    import moment from "moment";

    export default {
        name: "VehicleManager",
        data: () => ({
            dialog: false,
            menuVgp: false,
            menuCT: false,
            vehicles: [],
            defaultItem: {
                id: null,
                title: '',
                immat: '',
                modele: '',
                vgp: '',
                controlTechnic: ''
            },
            editedIndex: -1,
            editedItem: {
                id: null,
                title: '',
                immat: '',
                modele: '',
                vgp: '',
                controlTechnic: '',
            },
            headers: [
                {
                    text: 'Title',
                    value: 'title',
                },
                {
                    text: 'Immatriculation',
                    value: 'immat',
                    align: 'center'
                },
                {
                    text: 'Modèle',
                    value: 'modele',
                    align: 'center'
                },
                {
                    text: 'Dernière VGP',
                    value: 'vgp',
                    align: 'center',
                },
                {
                    text: 'Dernier controle technique',
                    value: 'controlTechnic',
                    align: 'center'
                },
                {
                    text: 'Actions',
                    value: 'actions',
                    align: 'center'
                }
            ]
        }),
        methods: {
            close() {
                this.dialog = false;
                setTimeout(() => {
                    this.editedItem = Object.assign({}, this.defaultItem);
                    this.editedIndex = -1
                }, 300)

            },
            save() {
                axios.post("/updateOrInsertVehicle", JSON.stringify(this.editedItem)).then((res) => this.editedItem.id = res.data.id);
                if (this.editedIndex > -1) {
                    Object.assign(this.vehicles[this.editedIndex], this.editedItem);
                } else {
                    this.vehicles.push(this.editedItem);
                }
                this.close()
            },
            editItem(item) {
                this.editedIndex = this.vehicles.indexOf(item);
                this.editedItem = Object.assign({}, item);
                this.dialog = true
            },
            deleteItem(item) {
                this.$dialog.confirm('Êtes vous sur de supprimer cette ligne ?', {
                    okText: 'Oui',
                    CancelText: 'Annuler'
                }).then(() => {
                    const index = this.vehicles.indexOf(item);
                    this.vehicles.splice(index, 1);
                    if (item.id) axios.delete("deleteVehicle/" + item.id)
                }).catch(() => {
                });
                console.log(item)
            },
            detailItem(item) {
                console.log(item)
            }
        },
        created() {
            axios.get("/fetchVehicles").then((res) => this.vehicles = res.data);
        },
        computed: {
            formTitle() {
                return this.editedIndex === -1 ? 'Nouveeau Véhicule' : 'Edition'
            },
            computedVgp() {
                return this.editedItem.vgp ? moment(this.editedItem.vgp).format('DD/MM/Y') : '';
            },
            computedCT() {
                return this.editedItem.controlTechnic ? moment(this.editedItem.controlTechnic).format('DD/MM/Y') : '';
            }
        },
        watch: {
            dialog(val) {
                val || this.close()
            },
        },
        filters: {
            formatDate(value) {
                if (value) {
                    return moment(value).format('DD/MM/Y');
                }
            }
        }
    }
</script>

<style scoped>

</style>